/******************************************************************************
  BMPTEST.PRG  Demonstration of functions in BMP2HPxx.LIB
  Written by:  Alain Boucher, July 1997.
  CopyRight:   ACTI-$OFT(r) - 2329 6684 QUEBEC INC.
               1363, Des Peupliers
               Mont St-Hilaire, Qc.
               Canada  J3G 4S6
               Tel: (514)944-4949
               Fax: (514)464-5726
               Web: http://www.vir.com/~acti-soft
               E-Mail: acti-soft@vir.com

  CA-Clipper 5.2: CLIPPER BMPTEST
                  RTLINK FI BMPTEST LIB CT,BMP2HP52
  CA-Clipper 5.3: CLIPPER BMPTEST
                  EXOSPACE FI BMPTEST LIB LLIBG,CTP,BMP2HP53
******************************************************************************/
Local cLptPort := 'LPT1'

Set( _SET_CURSOR,1 )
Set( _SET_SCOREBOARD,.f. )
Set( _SET_DELIMCHARS,'[]' )
Set( _SET_DELIMITERS,.t. )

Cls

SetColor( "N/W,N/W" )
@ 0,0 clear to 24,79
SetColor( "W+/B,W+/B" )
@ 0,0 Say Space(80)
@ 0,2 Say 'BMP2HPxx.LIB DEMO PROGRAM by ACTI-$OFT(r), Rel.7.07.16a, July 1997'
SetColor( "N/W,N/W" )

@ 4,2 Say "Enter printer port: " Get cLptPort picture "!!!!"
Read

if LastKey() <> 27
  TestBmp( cLptPort )
End

SetColor( "" )
Cls
Quit

/*****************************************************************************/
Stat Func TestBmp( cLptPort )

Local nError
Local cV
Local cBmpFile := "TEST.BMP"
Local nBmpType
Local cPrintPort := "LPT1"
Local aPixels := {}

cLptPort := if( cLptPort $ 'LPT1|LPT2|LPT3|COM1|COM2|COM3|COM4',;
                cLptPort,'LPT1' )

nError := BmpRead( cBmpFile,@aPixels )


Set( _SET_PRINTFILE,cPrintPort )
Set( _SET_PRINTER,.t. )

HpReset()                                   // Set up

// Prints a 8" wide by 1" high shaded area at 1/4" from
// left of physical page and 1/2" from top of physical page.
HpShade( .25,.50,8,1 )

// Prints a horizontal line of 8" by 4 pixel under shaded area.
HpHLine( .25,1.50,8,4 )

// Prints a vertical line of 1" by 4 pixel right of shaded area.
HpVLine( 8.20,.50,1,4 )

// Prints text over shaded area
HpText( 0.50,1.25,'BMP2HPxx.LIB DEMONSTRATION',32,.t. )

// Prints rectangle around the page.
HpFrame( .25,1.75,8,8.75 )

if nError == 0

  // Last element of aPixels always contains file type:
  // 1 for 1 bit mono, 4 for 4 bit 16 colors.
  nBmpType := aPixels[ Len( aPixels ) ]
  cV := cBmpFile + ' is '
  cV := cV + if( nBmpType == 1,"1 bit monochrome", ;
                               "4 bit, 16 colors" )

  HpText( 3,2.25,cV,14 )

  // Prints the image in its native size in 300 DPI resolution
  // at 1/2" from left of physical page and 3" from top of phy-
  // sical page.
  BmpHpPrint( cBmpFile,aPixels,0.5,3 )

  // Prints the image in its native size in 600 DPI resolution
  // at 1/2" from left of physical page and 6" from top of phy-
  // sical page.
  BmpHpPrint( cBmpFile,aPixels,0.5,6,0,0,600 )

  // Prints the image at wathever resolution it takes to fit in
  // a 4" by 4" space at 3" from left of physical page and 3" from
  // top of physical page.  Prints a frame around.
  BmpHpPrint( cBmpFile,aPixels,3,3,4,4,0,.t. )

End

HpReset()                                   // Ejects

Set( _SET_PRINTER,.f. )

Return( NIL )
/*****************************************************************************/

